/* ---------------------------------------------------------------------------
          Copyright (c) 2003-2004 Micrel, Inc.  All rights reserved.
   ---------------------------------------------------------------------------

   ks884xDiag.c - This file includes SCORs for diagnosis

   Modification History:
   PCD   08/25/04    Created file.
   ---------------------------------------------------------------------------
*/

#include <stdlib.h>
#include <string.h>
#include "target.h"

#undef   CLI_DEBUG


/* externally visible functions. */
       int   hwhelp_cmd ( void FAR *, void FAR **);
extern int   hwhelp ( void );

       int   hwread_cmd  ( void FAR *, void FAR **);
extern int   hwread ( unsigned char, unsigned long, unsigned char );

       int   hwwrite_cmd ( void FAR *, void FAR **);
extern int   hwwrite ( unsigned char, unsigned long, unsigned long, unsigned char );

       int   hwpoll_cmd  ( void FAR *, void FAR **);
extern int   hwpoll ( unsigned char, unsigned long, unsigned long, unsigned long, unsigned long );

       int   hwbufread_cmd  ( void FAR *, void FAR **);
extern int   hwbufread ( unsigned long, unsigned long, unsigned long );

       int   hwbufwrite_cmd ( void FAR *, void FAR **);
extern int   hwbufwrite ( unsigned long, unsigned long, unsigned char FAR * );

       int   hwbuffill_cmd  ( void FAR *, void FAR **);
extern int   hwbuffill ( unsigned char, unsigned long, unsigned long, unsigned long, unsigned long );

       int   hwbuftx_cmd ( void FAR *, void FAR **);
extern int   hwbuftx ( unsigned long, unsigned long, unsigned long, unsigned long, BOOLEAN, unsigned long );

       int   hwbufrx_cmd ( void FAR *, void FAR **);
extern int   hwbufrx ( unsigned long, unsigned long );

       int   hwtableread_cmd  ( void FAR *, void FAR **);
extern int   hwtableread ( char FAR *, unsigned long, unsigned long );

       int   hwtablewrite_cmd ( void FAR *, void FAR **);
extern int   hwtablewrite ( char FAR *, unsigned long, unsigned long, unsigned long );

       int   hwtableshow_cmd ( void FAR *, void FAR **);
extern int   hwtableshow ( char FAR *, unsigned long, unsigned long, BOOLEAN );

       int   hwclearmib_cmd (void FAR *, void FAR **);
extern int   hwclearmib (unsigned long);

       int   hwdumptx_cmd ( void FAR *, void FAR **);
extern int   hwdumptx ( unsigned long );

       int   hwdumprx_cmd ( void FAR *, void FAR **);
extern int   hwdumprx ( unsigned long );

       int   hwrxthres_cmd ( void FAR *, void FAR **);
extern int   hwrxthres ( unsigned long );

       int   hwtxthres_cmd ( void FAR *, void FAR **);
extern int   hwtxthres ( unsigned long );

       int   hwearly_cmd ( void FAR *, void FAR **);
extern int   hwearly ( unsigned long );

       int   hwmagic_cmd ( void FAR *, void FAR **);
extern int   hwmagic ( void );

       int   hwwolframe_cmd ( void FAR *, void FAR **);
extern int   hwwolframe ( unsigned long, unsigned long, unsigned char );

       int   hwrepeat_cmd ( void FAR *, void FAR **);
extern int   hwrepeat ( unsigned long );

       int   hwreset_cmd ( void FAR *, void FAR **);
extern int   hwreset ( unsigned long );

       int   hwtestcable_cmd ( void FAR *, void FAR **);
extern int   hwtestcable ( unsigned long );

       int   hwgetlink_cmd ( void FAR *, void FAR **);
extern int   hwgetlink ( unsigned long );

       int   hwsetlink_cmd ( void FAR *, void FAR **);
extern int   hwsetlink ( unsigned long, unsigned long );

       int   hwgetmac_cmd ( void FAR *, void FAR **);
extern int   hwgetmac ( void );

       int   hwgetip_cmd ( void FAR *, void FAR **);
extern int   hwgetip ( void );

       int   hwgettxcnt1_cmd ( void FAR *, void FAR **);
extern int   hwgettxcnt1 ( void );

       int   hwgettxcnt2_cmd ( void FAR *, void FAR **);
extern int   hwgettxcnt2 ( void );

       int   hwgetrxcnt1_cmd ( void FAR *, void FAR **);
extern int   hwgetrxcnt1 ( void );

       int   hwgetrxcnt2_cmd ( void FAR *, void FAR **);
extern int   hwgetrxcnt2 ( void );

       int   hwtxarp_cmd ( void FAR *, void FAR **);
extern int   hwtxarp ( unsigned long, unsigned long, unsigned char FAR *, unsigned char FAR * );


#ifdef KS_QC_TEST

       int   qctxtest_cmd (void FAR *, void FAR **);
extern int   qctxtest ( unsigned long, unsigned long );

       int   qcgetmib_cmd (void FAR *, void FAR **);
extern int   qcgetmib ( unsigned long, unsigned long );

       int   qcgetcable_cmd (void FAR *, void FAR **);
extern int   qcgetcable ( unsigned long );

       int   qcecho_cmd (void FAR *, void FAR **);
extern int   qcecho ( unsigned long );

#endif


/* local functions. */

/*****************************************************************/

/*****************************************************************
*
* Command: hwhelp
*
* Format: "hwhelp "
*
******************************************************************/
int hwhelp_cmd 
( 
   void FAR *p, 
   void FAR **pp 
)
{
   unsigned short FAR *pLen=p;
   unsigned short FAR argc=pLen[0];
   char FAR **argv=(char FAR **)pp;
   int i=0;

#ifdef CLI_DEBUG
   for(i=0;i<argc;i++)
	 DBG_PRINT("The token %d is argv[%d]=%s"NEWLINE,i+1,i,(char FAR *)argv[i]);
#endif

   return ( hwhelp () );
}


/*****************************************************************
*
* Command: hwread
*
* Format: "hwread  BankNum RegAddr Width"
*
******************************************************************/
int hwread_cmd 
(
   void FAR *p,
   void FAR **pp
)
{
   unsigned short FAR  *pLen=p;
   unsigned short FAR   argc=pLen[0];
   char   FAR **argv=(char FAR **)pp;
   int     i;

   unsigned char  BankNum;
   unsigned long  RegAddr;
   unsigned char  Width;


#ifdef CLI_DEBUG
   for(i=0;i<argc;i++)
	 DBG_PRINT("The token %d is argv[%d]=%s"NEWLINE,i+1,i,(char FAR *)argv[i]);
#endif


   /*
    * Get parameters
    */

   BankNum = (unsigned char) strtoul( argv[0], NULL, 16 );
   RegAddr = (unsigned long) strtoul( argv[1], NULL, 16 );
   Width =   (unsigned char) strtoul( argv[2], NULL, 16 );

   return (  hwread ( BankNum, RegAddr, Width ) );

}


/*****************************************************************
*
* Command: hwwrite
*
* Format: "hwwrite BankNum RegAddr RegData Width"
*
******************************************************************/
int hwwrite_cmd
(
   void FAR *p, 
   void FAR **pp 
)
{
   unsigned short FAR  *pLen=p;
   unsigned short FAR   argc=pLen[0];
   char   FAR **argv=(char FAR **)pp;
   int     i;

   unsigned char   BankNum;
   unsigned long   RegAddr;
   unsigned long   RegData;
   unsigned char   Width;


#ifdef CLI_DEBUG
   for(i=0;i<argc;i++)
	 DBG_PRINT("The token %d is argv[%d]=%s"NEWLINE,i+1,i,(char FAR *)argv[i]);
#endif


   /*
    * Get parameters
    */

   BankNum = (unsigned char) strtoul( argv[0], NULL, 16 );
   RegAddr = (unsigned long) strtoul( argv[1], NULL, 16 );
   RegData = (unsigned long) strtoul( argv[2], NULL, 16 );
   Width =   (unsigned char) strtoul( argv[3], NULL, 16 );

   return ( hwwrite ( BankNum, RegAddr, RegData, Width ) );

}

/*****************************************************************
*
* Command: hwpoll
*
* Format: "hwpoll BankNum RegAddr BitMask BitPattern TimeOut"
*
******************************************************************/
int hwpoll_cmd
(
   void FAR *p, 
   void FAR **pp 
)
{
   unsigned short FAR  *pLen=p;
   unsigned short FAR   argc=pLen[0];
   char   FAR **argv=(char FAR **)pp;
   int     i=0;
   unsigned char  BankNum;
   unsigned long  RegAddr;
   unsigned long  BitMask ;
   unsigned long  BitPattern ;
   unsigned long  TimeOut ;



#ifdef CLI_DEBUG
   for(i=0;i<argc;i++)
	 DBG_PRINT("The token %d is argv[%d]=%s"NEWLINE,i+1,i,(char FAR *)argv[i]);
#endif


   /*
    * Get parameters
    */

   BankNum    = (unsigned char) strtoul( argv[0], NULL, 16 );
   RegAddr    = (unsigned long) strtoul( argv[1], NULL, 16 );
   BitMask    = (unsigned long) strtoul( argv[2], NULL, 16 );
   BitPattern = (unsigned long) strtoul( argv[3], NULL, 16 );
   TimeOut    = (unsigned long) strtoul( argv[4], NULL, 16 );

   return ( hwpoll ( BankNum, RegAddr, BitMask, BitPattern, TimeOut ) );
}

/*****************************************************************
*
* Command: hwbufread
*
* Format: "hwbufread BufNum BufOffset Length"
*
******************************************************************/
int hwbufread_cmd
(
   void FAR *p, 
   void FAR **pp 
)
{
   unsigned short FAR  *pLen=p;
   unsigned short FAR   argc=pLen[0];
   char   FAR **argv=(char FAR **)pp;
   int     i=0;

   unsigned long  BufNum;
   unsigned long  BufOffset;
   unsigned long  CountTotal; 


#ifdef CLI_DEBUG
   for(i=0;i<argc;i++)
	 DBG_PRINT("The token %d is argv[%d]=%s"NEWLINE,i+1,i,(char FAR *)argv[i]);
#endif


   /*
    * Get parameters
    */

   BufNum     = (unsigned long) strtoul( argv[0], NULL, 16 );
   BufOffset  = (unsigned long) strtoul( argv[1], NULL, 16 );
   CountTotal = (unsigned long) strtoul( argv[2], NULL, 16 );

   return ( hwbufread ( BufNum, BufOffset, CountTotal ) );
}

/*****************************************************************
*
* Command: hwbufwrite
*
* Format: "hwbufwrite BufNum BufOffset BufData [...]"
*
******************************************************************/
int hwbufwrite_cmd
(
   void FAR *p, 
   void FAR **pp 
)
{
   unsigned short FAR  *pLen=p;
   unsigned short FAR   argc=pLen[0];
   char   FAR **argv=(char FAR **)pp;
   int     i=0;

   unsigned long  BufNum;
   unsigned long  BufOffset;
   unsigned char FAR *BufData;


#ifdef CLI_DEBUG
   for(i=0;i<argc;i++)
	 DBG_PRINT("The token %d is argv[%d]=%s"NEWLINE,i+1,i,(char FAR *)argv[i]);
#endif


   /*
    * Get parameters
    */

   BufNum     = (unsigned long) strtoul( argv[0], NULL, 16 );
   BufOffset  = (unsigned long) strtoul( argv[1], NULL, 16 );
   BufData    = (unsigned char FAR *)argv[2];

   return ( hwbufwrite ( BufNum, BufOffset, BufData ) );
}


/*****************************************************************
*
* Command: hwbuffill
*
* Format: "hwbuffill BufNum BufOffset BufData BufInc Length"
*
******************************************************************/
int hwbuffill_cmd
(
   void FAR *p, 
   void FAR **pp 
)
{
   unsigned short FAR  *pLen=p;
   unsigned short FAR   argc=pLen[0];
   char   FAR **argv=(char FAR **)pp;
   int     i=0;
   unsigned char  BufNum;
   unsigned long  BufOffset;
   unsigned long  BufData;
   unsigned long  BufInc;
   unsigned long  Count;


#ifdef CLI_DEBUG
   for(i=0;i<argc;i++)
	 DBG_PRINT("The token %d is argv[%d]=%s"NEWLINE,i+1,i,(char FAR *)argv[i]);
#endif


   /*
    * Get parameters
    */

   BufNum    = (unsigned long) strtoul( argv[0], NULL, 16 );
   BufOffset = (unsigned long) strtoul( argv[1], NULL, 16 );
   BufData   = (unsigned long) strtoul( argv[2], NULL, 16 );
   BufInc    = (unsigned long) strtoul( argv[3], NULL, 16 );
   Count     = (unsigned long) strtoul( argv[4], NULL, 16 );

   return ( hwbuffill ( BufNum, BufOffset, BufData, BufInc, Count ) );
}


/*****************************************************************
*
* Command: hwbuftx
*
* Format: "hwbuftx Port BufNum BufLen RepeatCount Delay"
*
******************************************************************/
int hwbuftx_cmd
(
   void FAR *p, 
   void FAR **pp 
)
{
   unsigned short FAR  *pLen=p;
   unsigned short FAR   argc=pLen[0];
   char   FAR **argv=(char FAR **)pp;
   int           i ;
   unsigned long   Port;
   unsigned long   BufNum;
   unsigned long   BufLen;
   unsigned long   RepeatCount;
   BOOLEAN         SameBuf;
   unsigned long   Delay;



#ifdef CLI_DEBUG
   for(i=0;i<argc;i++)
	 DBG_PRINT("The token %d is argv[%d]=%s"NEWLINE,i+1,i,(char FAR *)argv[i]);
#endif


   /*
    * Get parameters
    */

   Port        = (unsigned long) strtoul( argv[0], NULL, 16 );
   BufNum      = (unsigned long) strtoul( argv[1], NULL, 16 );
   BufLen      = (unsigned long) strtoul( argv[2], NULL, 16 );
   RepeatCount = (unsigned long) strtoul( argv[3], NULL, 16 );
   SameBuf     = (unsigned long) strtoul( argv[4], NULL, 16 );
   Delay       = (unsigned long) strtoul( argv[5], NULL, 16 );

   return ( hwbuftx ( Port, BufNum, BufLen, RepeatCount, SameBuf, Delay ) );
}


/*****************************************************************
*
* Command: hwbufrx
*
* Format: "hwbufrx  Port BufNum"
*
******************************************************************/
int hwbufrx_cmd
(
   void FAR *p, 
   void FAR **pp 
)
{
   unsigned short FAR  *pLen=p;
   unsigned short FAR   argc=pLen[0];
   char   FAR **argv=(char FAR **)pp;
   int           i ;
   unsigned long   BufNum;
   unsigned long   TimeOut ;


#ifdef CLI_DEBUG
   for(i=0;i<argc;i++)
	 DBG_PRINT("The token %d is argv[%d]=%s"NEWLINE,i+1,i,(char FAR *)argv[i]);
#endif


   /*
    * Get parameters
    */

   BufNum      = (unsigned long) strtoul( argv[0], NULL, 16 );
   TimeOut     = (unsigned long) strtoul( argv[1], NULL, 16 );

   return ( hwbufrx ( BufNum, TimeOut ) );
}

/*****************************************************************
*
* Command: hwtableread
*
* Format: "hwtableread  Table Index Count"
*
******************************************************************/
int hwtableread_cmd
(
   void FAR *p, 
   void FAR **pp 
)
{
   unsigned short FAR  *pLen=p;
   unsigned short FAR   argc=pLen[0];
   char   FAR **argv=(char FAR **)pp;
   int           i ;
   unsigned long Index ;
   unsigned long Count ;
   char FAR      *pbTableName ;


#ifdef CLI_DEBUG
   for(i=0;i<argc;i++)
	 DBG_PRINT("The token %d is argv[%d]=%s"NEWLINE,i+1,i,(char FAR *)argv[i]);
#endif

   /*
    * Get parameters
    */

   pbTableName = argv[0];
   Index = (unsigned long) strtoul( argv[1], NULL, 16 );
   Count = (unsigned long) strtoul( argv[2], NULL, 16 );

   return ( hwtableread (pbTableName, Index, Count ) );
}

/*****************************************************************
*
* Command: hwtablewrite
*
* Format: "hwtablewrite  Table Index RegDataH RegDataL"
*
******************************************************************/
int hwtablewrite_cmd
(
   void FAR *p, 
   void FAR **pp 
)
{
   unsigned short FAR  *pLen=p;
   unsigned short FAR   argc=pLen[0];
   char   FAR **argv=(char FAR **)pp;
   int           i ;
   unsigned long Index ;
   char FAR      *pbTableName ;
   unsigned long RegDataH ;
   unsigned long RegDataL ;


#ifdef CLI_DEBUG
   for(i=0;i<argc;i++)
	 DBG_PRINT("The token %d is argv[%d]=%s"NEWLINE,i+1,i,(char FAR *)argv[i]);
#endif


   /*
    * Get parameters
    */

   pbTableName = argv[0];
   Index       = (unsigned long) strtoul( argv[1], NULL, 16 );
   RegDataH    = (unsigned long) strtoul( argv[2], NULL, 16 );
   RegDataL    = (unsigned long) strtoul( argv[3], NULL, 16 );

   return ( hwtablewrite ( pbTableName, Index, RegDataH, RegDataL ) );
}


/*****************************************************************
*
* Command: hwtableshow
*
* Format: "hwtableshow  Table Index Count"
*
******************************************************************/
int hwtableshow_cmd
(
   void FAR *p, 
   void FAR **pp 
)
{
   unsigned short FAR  *pLen=p;
   unsigned short FAR   argc=pLen[0];
   char   FAR **argv=(char FAR **)pp;
   int           i ;
   unsigned long  Index ;
   unsigned long  Count ;
   char FAR      *pbTableName ;



#ifdef CLI_DEBUG
   for(i=0;i<argc;i++)
	 DBG_PRINT("The token %d is argv[%d]=%s"NEWLINE,i+1,i,(char FAR *)argv[i]);
#endif

   /*
    * Get parameters
    */

   pbTableName = argv[0];
   Index = (unsigned long) strtoul( argv[1], NULL, 16 );
   Count = (unsigned long) strtoul( argv[2], NULL, 16 );

   return ( hwtableshow ( pbTableName, Index, Count, TRUE ) );
}


/*****************************************************************
*
* Command: hwclearmib
*
* Format: "hwclearmib Port"
*
******************************************************************/
int hwclearmib_cmd
(
   void FAR *p, 
   void FAR **pp 
)
{
   unsigned short FAR  *pLen=p;
   unsigned short FAR   argc=pLen[0];
   char   FAR **argv=(char FAR **)pp;
   int            i ;
   unsigned long  Port;


#ifdef CLI_DEBUG
   for(i=0;i<argc;i++)
	 DBG_PRINT("The token %d is argv[%d]=%s"NEWLINE,i+1,i,(char FAR *)argv[i]);
#endif

   /*
    * Get parameters
    */

   Port = (unsigned long) strtoul( argv[0], NULL, 16 );

   return ( hwclearmib ( Port ) );
}


/*****************************************************************
*
* Command: hwdumprx
*
* Format: "hwdumprx  DumpFlag"
*
******************************************************************/
int hwdumprx_cmd 
(
   void FAR *p, 
   void FAR **pp 
)
{
   unsigned short FAR  *pLen=p;
   unsigned short FAR   argc=pLen[0];
   char   FAR **argv=(char FAR **)pp;
   int     i;

   unsigned long  DumpFlag ;


#ifdef CLI_DEBUG
   for(i=0;i<argc;i++)
	 DBG_PRINT("The token %d is argv[%d]=%s"NEWLINE,i+1,i,(char FAR *)argv[i]);
#endif


   /*
    * Get parameters
    */

   DumpFlag = (unsigned long) strtoul( argv[0], NULL, 16 );

   return (hwdumprx (DumpFlag));
}


/*****************************************************************
*
* Command: hwdumptx
*
* Format: "hwdumptx  DumpFlag"
*
******************************************************************/
int hwdumptx_cmd 
(
   void FAR *p, 
   void FAR **pp 
)
{
   unsigned short FAR  *pLen=p;
   unsigned short FAR   argc=pLen[0];
   char   FAR **argv=(char FAR **)pp;
   int     i=0;

   unsigned long  DumpFlag;


#ifdef CLI_DEBUG
   for(i=0;i<argc;i++)
	 DBG_PRINT("The token %d is argv[%d]=%s"NEWLINE,i+1,i,(char FAR *)argv[i]);
#endif


   /*
    * Get parameters
    */

   DumpFlag = (unsigned long) strtoul( argv[0], NULL, 16 );

   return (  hwdumptx ( DumpFlag ) );
}


#ifdef DEF_KS8841
#ifdef KS_ISA_BUS
/*****************************************************************
*
* Command: hwrxthres
*
* Format: "hwrxthres  FData"
*
******************************************************************/
int hwrxthres_cmd 
(
   void FAR *p, 
   void FAR **pp 
)
{
   unsigned short FAR  *pLen=p;
   unsigned short FAR   argc=pLen[0];
   char   FAR **argv=(char FAR **)pp;
   int     i;

   unsigned long  FData ;


#ifdef CLI_DEBUG
   for(i=0;i<argc;i++)
	 DBG_PRINT("The token %d is argv[%d]=%s"NEWLINE,i+1,i,(char FAR *)argv[i]);
#endif


   /*
    * Get parameters
    */

   FData = (unsigned long) strtoul( argv[0], NULL, 16 );

   return (hwrxthres (FData));
}


/*****************************************************************
*
* Command: hwtxthres
*
* Format: "hwtxthres  FData"
*
******************************************************************/
int hwtxthres_cmd 
(
   void FAR *p, 
   void FAR **pp 
)
{
   unsigned short FAR  *pLen=p;
   unsigned short FAR   argc=pLen[0];
   char   FAR **argv=(char FAR **)pp;
   int     i;

   unsigned long  FData ;


#ifdef CLI_DEBUG
   for(i=0;i<argc;i++)
	 DBG_PRINT("The token %d is argv[%d]=%s"NEWLINE,i+1,i,(char FAR *)argv[i]);
#endif


   /*
    * Get parameters
    */

   FData = (unsigned long) strtoul( argv[0], NULL, 16 );

   return (hwtxthres (FData));
}


/*****************************************************************
*
* Command: hwearly_cmd
*
* Format: "hwearly  Flag"
*
******************************************************************/
int hwearly_cmd 
(
   void FAR *p, 
   void FAR **pp 
)
{
   unsigned short FAR  *pLen=p;
   unsigned short FAR   argc=pLen[0];
   char   FAR **argv=(char FAR **)pp;
   int     i;

   unsigned long  Flag ;


#ifdef CLI_DEBUG
   for(i=0;i<argc;i++)
	 DBG_PRINT("The token %d is argv[%d]=%s"NEWLINE,i+1,i,(char FAR *)argv[i]);
#endif


   /*
    * Get parameters
    */

   Flag = (unsigned long) strtoul( argv[0], NULL, 16 );

   return (hwearly (Flag));
}
#endif /* #ifdef KS_ISA_BUS */

#endif /* #ifdef DEF_KS8841 */


/*****************************************************************
*
* Command: hwmagic_cmd
*
* Format: "hwmagic "
*
******************************************************************/
int hwmagic_cmd 
(
   void FAR *p, 
   void FAR **pp 
)
{
   unsigned short FAR  *pLen=p;
   unsigned short FAR   argc=pLen[0];
   char   FAR **argv=(char FAR **)pp;
   int     i;



#ifdef CLI_DEBUG
   for(i=0;i<argc;i++)
	 DBG_PRINT("The token %d is argv[%d]=%s"NEWLINE,i+1,i,(char FAR *)argv[i]);
#endif

   return (hwmagic ());
}

/*****************************************************************
*
* Command: hwwolframe
*
* Format: "hwwolframe  FrameNum  CRC  ByteMask"
*
******************************************************************/
int hwwolframe_cmd 
(
   void FAR *p, 
   void FAR **pp 
)
{
   unsigned short FAR  *pLen=p;
   unsigned short FAR   argc=pLen[0];
   char   FAR **argv=(char FAR **)pp;
   int     i;
   unsigned long   FrameNum;
   unsigned long   CRC;
   unsigned char   ByteMask;



#ifdef CLI_DEBUG
   for(i=0;i<argc;i++)
	 DBG_PRINT("The token %d is argv[%d]=%s"NEWLINE,i+1,i,(char FAR *)argv[i]);
#endif

   /*
    * Get parameters
    */

   FrameNum = (unsigned long) strtoul( argv[0], NULL, 16 );
   CRC      = (unsigned long) strtoul( argv[1], NULL, 16 );
   ByteMask = (unsigned char) strtoul( argv[2], NULL, 16 );

   return (hwwolframe ( FrameNum, CRC, ByteMask ));
}

/*****************************************************************
*
* Command: hwclearpme_cmd
*
* Format: "hwclearpme "
*
******************************************************************/
int hwclearpme_cmd 
(
   void FAR *p, 
   void FAR **pp 
)
{
   unsigned short FAR  *pLen=p;
   unsigned short FAR   argc=pLen[0];
   char   FAR **argv=(char FAR **)pp;
   int     i;



#ifdef CLI_DEBUG
   for(i=0;i<argc;i++)
	 DBG_PRINT("The token %d is argv[%d]=%s"NEWLINE,i+1,i,(char FAR *)argv[i]);
#endif

   return (hwclearpme ());
}


#ifdef DEF_KS8842
/*****************************************************************
*
* Command: hwrepeat
*
* Format: "hwrepeat  Flag"
*
******************************************************************/
int hwrepeat_cmd 
(
   void FAR *p, 
   void FAR **pp 
)
{
   unsigned short FAR  *pLen=p;
   unsigned short FAR   argc=pLen[0];
   char   FAR **argv=(char FAR **)pp;
   int     i;

   unsigned long  Flag ;


#ifdef CLI_DEBUG
   for(i=0;i<argc;i++)
	 DBG_PRINT("The token %d is argv[%d]=%s"NEWLINE,i+1,i,(char FAR *)argv[i]);
#endif


   /*
    * Get parameters
    */

   Flag = (unsigned long) strtoul( argv[0], NULL, 16 );

   return (hwrepeat (Flag));
}
#endif /* #ifdef DEF_KS8842 */


/*****************************************************************
*
* Command: hwreset
*
* Format: "hwreset  TimeOut"
*
******************************************************************/
int hwreset_cmd 
(
   void FAR *p, 
   void FAR **pp 
)
{
   unsigned short FAR  *pLen=p;
   unsigned short FAR   argc=pLen[0];
   char   FAR **argv=(char FAR **)pp;
   int     i;

   unsigned long  TimeOut ;


#ifdef CLI_DEBUG
   for(i=0;i<argc;i++)
	 DBG_PRINT("The token %d is argv[%d]=%s"NEWLINE,i+1,i,(char FAR *)argv[i]);
#endif


   /*
    * Get parameters
    */

   TimeOut = (unsigned long) strtoul( argv[0], NULL, 16 );

   return (hwreset (TimeOut));
}


/*****************************************************************
*
* Command: hwtestcable
*
* Format: "hwtestcable  Port"
*
******************************************************************/
int hwtestcable_cmd 
(
   void FAR *p, 
   void FAR **pp 
)
{
   unsigned short FAR  *pLen=p;
   unsigned short FAR   argc=pLen[0];
   char   FAR **argv=(char FAR **)pp;
   int     i;

   unsigned long  Port ;


#ifdef CLI_DEBUG
   for(i=0;i<argc;i++)
	 DBG_PRINT("The token %d is argv[%d]=%s"NEWLINE,i+1,i,(char FAR *)argv[i]);
#endif


   /*
    * Get parameters
    */

   Port = (unsigned long) strtoul( argv[0], NULL, 16 );

   return (hwtestcable (Port));
}


/*****************************************************************
*
* Command: hwgetlink
*
* Format: "hwgetlink  Port"
*
******************************************************************/
int hwgetlink_cmd 
(
   void FAR *p, 
   void FAR **pp 
)
{
   unsigned short FAR  *pLen=p;
   unsigned short FAR   argc=pLen[0];
   char   FAR **argv=(char FAR **)pp;
   int     i;

   unsigned long  Port ;


#ifdef CLI_DEBUG
   for(i=0;i<argc;i++)
	 DBG_PRINT("The token %d is argv[%d]=%s"NEWLINE,i+1,i,(char FAR *)argv[i]);
#endif


   /*
    * Get parameters
    */

   Port = (unsigned long) strtoul( argv[0], NULL, 16 );

   return (hwgetlink (Port));
}


/*****************************************************************
*
* Command: hwsetlink
*
* Format: "hwsetlink  Port Data"
*
******************************************************************/
int hwsetlink_cmd 
(
   void FAR *p, 
   void FAR **pp 
)
{
   unsigned short FAR  *pLen=p;
   unsigned short FAR   argc=pLen[0];
   char   FAR **argv=(char FAR **)pp;
   int     i;

   unsigned long  Port ;
   unsigned long  Data ;


#ifdef CLI_DEBUG
   for(i=0;i<argc;i++)
	 DBG_PRINT("The token %d is argv[%d]=%s"NEWLINE,i+1,i,(char FAR *)argv[i]);
#endif


   /*
    * Get parameters
    */

   Port = (unsigned long) strtoul( argv[0], NULL, 16 );
   Data = (unsigned long) strtoul( argv[1], NULL, 16 );

   return (hwsetlink (Port, Data));
}

/*****************************************************************
*
* Command: hwgetmac
*
* Format: "hwgetmac "
*
******************************************************************/
int hwgetmac_cmd 
( 
   void FAR *p, 
   void FAR **pp 
)
{
   unsigned short FAR *pLen=p;
   unsigned short FAR argc=pLen[0];
   char FAR **argv=(char FAR **)pp;
   int i=0;

#ifdef CLI_DEBUG
   for(i=0;i<argc;i++)
	 DBG_PRINT("The token %d is argv[%d]=%s"NEWLINE,i+1,i,(char FAR *)argv[i]);
#endif

   return ( hwgetmac () );
}

/*****************************************************************
*
* Command: hwgetip
*
* Format: "hwgetip "
*
******************************************************************/
int hwgetip_cmd 
( 
   void FAR *p, 
   void FAR **pp 
)
{
   unsigned short FAR *pLen=p;
   unsigned short FAR argc=pLen[0];
   char FAR **argv=(char FAR **)pp;
   int i=0;

#ifdef CLI_DEBUG
   for(i=0;i<argc;i++)
	 DBG_PRINT("The token %d is argv[%d]=%s"NEWLINE,i+1,i,(char FAR *)argv[i]);
#endif

   return ( hwgetip () );
}

/*****************************************************************
*
* Command: hwgettxcnt1
*
* Format: "hwgettxcnt1 "
*
******************************************************************/
int hwgettxcnt1_cmd 
( 
   void FAR *p, 
   void FAR **pp 
)
{
   unsigned short FAR *pLen=p;
   unsigned short FAR argc=pLen[0];
   char FAR **argv=(char FAR **)pp;
   int i=0;

#ifdef CLI_DEBUG
   for(i=0;i<argc;i++)
	 DBG_PRINT("The token %d is argv[%d]=%s"NEWLINE,i+1,i,(char FAR *)argv[i]);
#endif

   return ( hwgettxcnt1 () );
}

/*****************************************************************
*
* Command: hwgettxcnt2
*
* Format: "hwgettxcnt2 "
*
******************************************************************/
int hwgettxcnt2_cmd 
( 
   void FAR *p, 
   void FAR **pp 
)
{
   unsigned short FAR *pLen=p;
   unsigned short FAR argc=pLen[0];
   char FAR **argv=(char FAR **)pp;
   int i=0;

#ifdef CLI_DEBUG
   for(i=0;i<argc;i++)
	 DBG_PRINT("The token %d is argv[%d]=%s"NEWLINE,i+1,i,(char FAR *)argv[i]);
#endif

   return ( hwgettxcnt2 () );
}

/*****************************************************************
*
* Command: hwgetrxcnt1
*
* Format: "hwgetrxcnt1 "
*
******************************************************************/
int hwgetrxcnt1_cmd 
( 
   void FAR *p, 
   void FAR **pp 
)
{
   unsigned short FAR *pLen=p;
   unsigned short FAR argc=pLen[0];
   char FAR **argv=(char FAR **)pp;
   int i=0;

#ifdef CLI_DEBUG
   for(i=0;i<argc;i++)
	 DBG_PRINT("The token %d is argv[%d]=%s"NEWLINE,i+1,i,(char FAR *)argv[i]);
#endif

   return ( hwgetrxcnt1 () );
}

/*****************************************************************
*
* Command: hwgetrxcnt2
*
* Format: "hwgetrxcnt2 "
*
******************************************************************/
int hwgetrxcnt2_cmd 
( 
   void FAR *p, 
   void FAR **pp 
)
{
   unsigned short FAR *pLen=p;
   unsigned short FAR argc=pLen[0];
   char FAR **argv=(char FAR **)pp;
   int i=0;

#ifdef CLI_DEBUG
   for(i=0;i<argc;i++)
	 DBG_PRINT("The token %d is argv[%d]=%s"NEWLINE,i+1,i,(char FAR *)argv[i]);
#endif

   return ( hwgetrxcnt2 () );
}

/*****************************************************************
*
* Command: hwtxarp
*
* Format: "hwtxarp  Port  Repeat  MAC  IP"
*
******************************************************************/
int hwtxarp_cmd 
( 
   void FAR *p, 
   void FAR **pp 
)
{
   unsigned short FAR *pLen=p;
   unsigned short FAR argc=pLen[0];
   char FAR **argv=(char FAR **)pp;
   int i=0;

   unsigned long      Port;
   unsigned long      RepeatCount;
   unsigned char FAR *pMac;
   unsigned char FAR *pIp;


#ifdef CLI_DEBUG
   for(i=0;i<argc;i++)
	 DBG_PRINT("The token %d is argv[%d]=%s"NEWLINE,i+1,i,(char FAR *)argv[i]);
#endif

   /*
    * Get parameters
    */

   Port        = (unsigned long) strtoul( argv[0], NULL, 16 );
   RepeatCount = (unsigned long) strtoul( argv[1], NULL, 16 );
   pMac        = (unsigned char FAR *)argv[2];
   pIp         = (unsigned char FAR *)argv[3];

   return ( hwtxarp ( Port, RepeatCount, pMac, pIp ) );
}


#ifdef KS_QC_TEST

/*--  This section are for FAB QC testing only ------------------------------*/


/******************************************************************************
*
* Command: qctxtest
*
* Format: "qctxtest Port RepeatCount"
*
******************************************************************************/
int qctxtest_cmd
(
   void FAR *p, 
   void FAR **pp 
)
{
   unsigned short FAR  *pLen=p;
   unsigned short FAR   argc=pLen[0];
   char   FAR **argv=(char FAR **)pp;
   int           i ;
   unsigned long   Port;
   unsigned long   RepeatCount;



#ifdef CLI_DEBUG
   for(i=0;i<argc;i++)
	 DBG_PRINT("The token %d is argv[%d]=%s"NEWLINE,i+1,i,(char FAR *)argv[i]);
#endif


   /*
    * Get parameters
    */

   Port        = (unsigned long) strtoul( argv[0], NULL, 16 );
   RepeatCount = (unsigned long) strtoul( argv[1], NULL, 16 );

   return ( qctxtest ( Port, RepeatCount ) );
}

/******************************************************************************
*
* Command: qcgetcable_cmd
*
* Format: "qcgetcable  Port"
*
******************************************************************************/
int qcgetcable_cmd
(
   void FAR *p, 
   void FAR **pp 
)
{
   unsigned short FAR  *pLen=p;
   unsigned short FAR   argc=pLen[0];
   char   FAR **argv=(char FAR **)pp;
   int           i ;
   unsigned long   Port;



#ifdef CLI_DEBUG
   for(i=0;i<argc;i++)
	 DBG_PRINT("The token %d is argv[%d]=%s"NEWLINE,i+1,i,(char FAR *)argv[i]);
#endif


   /*
    * Get parameters
    */

   Port     = (unsigned long) strtoul( argv[0], NULL, 16 );

   return ( qcgetcable ( Port ) );
}

/******************************************************************************
*
* Command: qcgetmib
*
* Format: "qcgetmib Port MibIndex"
*
******************************************************************************/
int qcgetmib_cmd
(
   void FAR *p, 
   void FAR **pp 
)
{
   unsigned short FAR  *pLen=p;
   unsigned short FAR   argc=pLen[0];
   char   FAR **argv=(char FAR **)pp;
   int           i ;
   unsigned long   Port;
   unsigned long   MibIndex;



#ifdef CLI_DEBUG
   for(i=0;i<argc;i++)
	 DBG_PRINT("The token %d is argv[%d]=%s"NEWLINE,i+1,i,(char FAR *)argv[i]);
#endif


   /*
    * Get parameters
    */

   Port     = (unsigned long) strtoul( argv[0], NULL, 16 );
   MibIndex = (unsigned long) strtoul( argv[1], NULL, 16 );

   return ( qcgetmib ( Port, MibIndex ) );
}

/******************************************************************************
*
* Command: qcecho
*
* Format: "qcecho Flag"
*
******************************************************************************/
int qcecho_cmd
(
   void FAR *p, 
   void FAR **pp 
)
{
   unsigned short FAR  *pLen=p;
   unsigned short FAR   argc=pLen[0];
   char   FAR **argv=(char FAR **)pp;
   int           i ;
   unsigned long   Flag;



#ifdef CLI_DEBUG
   for(i=0;i<argc;i++)
	 DBG_PRINT("The token %d is argv[%d]=%s"NEWLINE,i+1,i,(char FAR *)argv[i]);
#endif


   /*
    * Get parameters
    */

   Flag = (unsigned long) strtoul( argv[0], NULL, 16 );

   return ( qcecho ( Flag ) );
}

#endif /* #ifdef KS_QC_TEST */



